#   File:       test.PPC.make
#   Target:     test
#   Sources:    test.c

Makefile = test.PPC.make

object_folder = ":objects_PPC:"

fsource =	test.f 
			
csource =	F2Cmain.c

fobjs 	=	{object_folder}'test.f.o'
			
cobjs	=	{object_folder}'F2Cmain.c.o'


objects =	{fobjs} 
			{cobjs}

PPCC			=	MWCPPC
PPCCOptions	=	-align power -nosyspath -i "{CIncludes}" -d MPW_CW_F2C -w off
F2C			=	F2C
#F2COptions	=	-f -!i8 -A -P -a -E -ec -!R -r8 -s -w66 -Nq150 -Nx200 -Ns801 -Nc20 -Nn401 -NL200 -NC99 -Nl256 
F2COptions	=	-f -!i8 -A -E -ec -a -!R -r8 -w66
PPCLink		=	MWLinkPPC
PPCLinkOptions	=	-d -c 'MPS ' -t 'MPST' -fastlink off

test.PPC  {objects} {Makefile}
    {PPCLink} {PPCLinkOptions} 
        {OBJECTS} 
		"{MWPPCLibraries}"MWStdCRuntime.Lib   
		"{MWPPCLibraries}"StdCLib   
		"{MWPPCLibraries}"InterfaceLib   
		"{MWPPCLibraries}PPCToolLibs.o" 
		"{MWPPCLibraries}"MathLib   
        "{F2CLibraries}"libI77.PPC   
        "{F2CLibraries}"libF77.PPC   
        -o test.PPC

test.PPC   test.r {Makefile}
	Rez -a -o test.PPC -d APPNAME="test.PPC" test.r

.f.o		.f
	{F2C} {F2COptions} {Default}.f 	#compile the fortran and then compile the resulting C file.
	setfile -t "TEXT" -c "MPS " {default}.c
	{PPCC} {default}.c {PPCCOptions} 
	-o {targDir}{default}.f.o


.c.o  .c
	{PPCC} {default}.c {PPCCOptions} 
	-o {targDir}{default}.c.o


# If your FORTRAN code has common blocks add common.c.o to the cobjs list 
# and then this rule should take care of it
common.c		{fobjs}
	setfile -t "TEXT" -c "MPS " ?+_com.c
	catenate ?+_com.c > {targDir}{Targ}	#This puts all the common block files into one file for compiling.
										#The wild card lets us add common blocks to the fortran code
										#without having to change the makefile!  The common block files all
										#end with _com.c

{objects}		{Makefile}		#do a full rebuild if the makefile changes

{object_folder}	 :

{object_folder}'test.f.o'   'test.f'

{object_folder}'F2Cmain.c.o'	 'F2Cmain.c'

{object_folder}'common.c.o'	 'common.c'

# makefile end

